<?php

//////////
///
///   note.inc.php
///
//////////

require_once('lib/commons.inc.php');



/*************\
*   METHODS   *
\*************/

$dm['note.add'] = array('func'   => 'note_add',
                        'perm'   => AL_VIEW,
                        'escape' => true);

$dm['note.mod'] = array('func'   => 'note_mod',
                        'perm'   => AL_VIEW,
                        'escape' => true);

$dm['note.del'] = array('func'   => 'note_del',
                        'perm'   => AL_VIEW,
                        'escape' => true);

$dm['note.get'] = array('func'   => 'note_get',
                        'perm'   => AL_VIEW,
                        'escape' => true);



/***************\
*   FUNCTIONS   *
\***************/

function note_add($content, $private, $log_id)
{
   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `log` ";
   $sql .= "WHERE `log_id` = '$log_id'";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return error('note', 'nosuchlog');
   }

   if(!in_array($ret['payload'][0]->backdoor_id, $_SESSION['authbackdoorid'])) {
      return error('note', 'nosuchlog');
   }

   $sql  = "INSERT INTO `note` (`timestamp`, ";
   $sql .=                     "`content`, ";
   $sql .=                     "`user_id`, ";
   $sql .=                     "`log_id`) ";
   $sql .= "VALUES (UTC_TIMESTAMP, ";
   $sql .=         "'$content', ";
   $sql .= ($private ? "'{$_SESSION['authuserid']}', " : "NULL, " );
   $sql .=         "'$log_id')";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   $sql = "SELECT LAST_INSERT_ID() AS `note_id`";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   }

   return success((integer)$ret['payload'][0]->note_id);
}

function note_mod($note_id, $content)
{
   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `note` ";
   $sql .= "JOIN `log` ";
   $sql .= "USING (`log_id`) ";
   $sql .= "WHERE `note_id` = '$note_id' AND ";
   $sql .=      "(`user_id` = '{$_SESSION['authuserid']}' OR ";
   $sql .=       "`user_id` IS NULL)";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return error('note', 'nosuchnote');
   }

   if(!in_array($ret['payload'][0]->backdoor_id, $_SESSION['authbackdoorid'])) {
      return error('note', 'nosuchnote');
   }

   $sql  = "UPDATE `note` ";
   $sql .= "SET `timestamp` = UTC_TIMESTAMP(), ";
   $sql .=     "`content` = '$content' ";
   $sql .= "WHERE `note_id` = '$note_id'";

   return db_query($sql);
}

function note_del($note_id)
{
   $sql  = "SELECT `backdoor_id` ";
   $sql .= "FROM `note` ";
   $sql .= "JOIN `log` ";
   $sql .= "USING (`log_id`) ";
   $sql .= "WHERE `note_id` = '$note_id' AND ";
   $sql .=      "(`user_id` = '{$_SESSION['authuserid']}' OR ";
   $sql .=       "`user_id` IS NULL)";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return error('note', 'nosuchnote');
   }

   if(!in_array($ret['payload'][0]->backdoor_id, $_SESSION['authbackdoorid'])) {
      return error('note', 'nosuchnote');
   }

   $sql  = "DELETE FROM `note` ";
   $sql .= "WHERE `note_id` = '$note_id'";

   return db_query($sql);
}

function note_get($log_id)
{
   foreach($log_id as $l) {
      $sql  = "SELECT `backdoor_id` ";
      $sql .= "FROM `log` ";
      $sql .= "WHERE `log_id` = '$l'";

      $ret = db_query($sql);

      if(!is_success($ret)) {
         return $ret;
      } else if($ret['payload'] === false) {
         return error('note', 'nosuchlog');
      }

      if(!in_array($ret['payload'][0]->backdoor_id, $_SESSION['authbackdoorid'])) {
         return error('note', 'nosuchlog');
      }
   }

   $sql  = "SELECT `note_id`, ";
   $sql .=        "`timestamp`, ";
   $sql .=        "`content`, ";
   $sql .=        "IF(ISNULL(`user_id`), 0, 1) AS `private`, ";
   $sql .=        "`log_id` ";
   $sql .= "FROM `note` ";
   $sql .= "WHERE `log_id` IN ('".implode("', '", $log_id)."')";

   $ret = db_query($sql);

   if(!is_success($ret)) {
      return $ret;
   } else if($ret['payload'] === false) {
      return success(array());
   }

   foreach($ret['payload'] as &$r) {
      $r->private = ($r->private ? true : false);
   }
   unset($r);

   return $ret;
}

?>
