<?php

//////////
///
///   upload.php
///
//////////

require_once('lib/authlevel.inc.php');



/**********\
*   MAIN   *
\**********/

$authuser = (isset($_SESSION['authuser']) ? $_SESSION['authuser'] : '');
$authuserid = (isset($_SESSION['authuserid']) ? $_SESSION['authuserid'] : 'none');

error_log("upload(begin): user=$authuser($authuserid)");

header('Content-Type: text/plain');

if(!(($al & (AL_TECH | AL_SERV)) && isset($_FILES['file']['tmp_name']))) {
   error_log("upload(error): user=$authuser($authuserid), ".
                            'error="Invalid request"');
   error_log("upload(ended): user=$authuser($authuserid)");

   header(true, true, 403);
   exit('Invalid request');
}

$tmpfile = tempnam(sys_get_temp_dir(), 'upload');

if(!move_uploaded_file($_FILES['file']['tmp_name'], $tmpfile)) {
   error_log("upload(error): user=$authuser($authuserid), ".
                            'error="Invalid request"');
   error_log("upload(ended): user=$authuser($authuserid)");

   header(true, true, 403);
   exit('Invalid request');
}

$_SESSION['upload'][basename($tmpfile)] = true;

echo basename($tmpfile);

error_log("upload(ended): user=$authuser($authuserid)");

?>
