<?php

function extract_required_files($filename, $path)
{
   $list = array();

   $content = file_get_contents($path.'/'.$filename);
   preg_match_all('{require_once\(\'(?P<filename>.*?)\'\)}', $content, $matches);
   unset($content);

   foreach($matches['filename'] as $m) {
      $list[] = $path.'/'.$m;
      $list = array_unique(array_merge($list, extract_required_files($m, $path)));
   }

   return $list;
}

function merge_files($sourcefile, $destfile)
{
   $list = extract_required_files(basename($sourcefile), dirname($sourcefile));
   $list[] = $sourcefile;

   file_put_contents($destfile, "<?php");
   foreach($list as $l) {
      $content = preg_replace('{<\?php|require_once\(.*?\);|\?>}', '', file_get_contents($l));
      file_put_contents($destfile, $content, FILE_APPEND);
   }
   file_put_contents($destfile, "?>\n", FILE_APPEND);

   return;
}

mkdir('..\htdocs');
exec('copy ..\htdocs.php\ ..\htdocs');
mkdir('..\htdocs\etc');
exec('copy ..\htdocs.php\etc ..\htdocs\etc');
mkdir('..\htdocs\sql');
exec('copy ..\htdocs.php\sql ..\htdocs\sql');
mkdir('..\htdocs\web');
mkdir('..\htdocs\web\trace');
mkdir('..\htdocs\web\trace\img');
exec('copy ..\htdocs.php\web\trace ..\htdocs\web\trace');
exec('copy ..\htdocs.php\web\trace\img ..\htdocs\web\trace\img');
mkdir('..\htdocs\zip');
exec('copy ..\htdocs.php\zip ..\htdocs\zip');

mkdir('..\tmp');

merge_files('..\htdocs.php\server.php', '..\tmp\server.php');
exec('..\bin\rcscrypt ..\tmp\server.php ..\htdocs\server.php');
unlink('..\tmp\server.php');
merge_files('..\htdocs.php\upload.php', '..\tmp\upload.php');
exec('..\bin\rcscrypt ..\tmp\upload.php ..\htdocs\upload.php');
unlink('..\tmp\upload.php');
merge_files('..\htdocs.php\download.php', '..\tmp\download.php');
exec('..\bin\rcscrypt ..\tmp\download.php ..\htdocs\download.php');
unlink('..\tmp\download.php');
merge_files('..\htdocs.php\blotter.php', '..\tmp\blotter.php');
exec('..\bin\rcscrypt ..\tmp\blotter.php ..\htdocs\blotter.php');
unlink('..\tmp\blotter.php');

rmdir('..\tmp');

?>
